import { Subject, Observable } from 'rxjs';
import { services } from 'typescript-angular-utilities';
import __array = services.array;
import { IDataSource } from './dataSource';
import { DataSourceBase } from './dataSourceBase.service';
import { IDataSourceProcessor } from './dataSourceProcessor.service';
export { IDataSource };
export interface IDataSetFunction<TDataType> {
    (params: any): Promise<TDataType[]> | Observable<TDataType[]>;
}
export interface IAsyncDataSource<TDataType> extends IDataSource<TDataType> {
    reload(): any;
    getDataSet: IDataSetFunction<TDataType>;
    reloaded: Subject<void>;
}
export declare class AsyncDataSource<TDataType> extends DataSourceBase<TDataType> implements IAsyncDataSource<TDataType> {
    protected synchronizedRequests: Subject<Observable<TDataType[]>>;
    reloaded: Subject<void>;
    getDataSet: IDataSetFunction<TDataType>;
    constructor(getDataSet: IDataSetFunction<TDataType>, dataSourceProcessor: IDataSourceProcessor, array: __array.IArrayUtility);
    reload(): void;
    protected resolveReload(data: TDataType[]): void;
    protected getParams(): any;
}
