import { Observable } from 'rxjs';
import { services } from 'typescript-angular-utilities';
import __array = services.array;
import { IAsyncDataSource, AsyncDataSource } from '../asyncDataSource.service';
import { IDataSourceProcessor } from '../dataSourceProcessor.service';
export { IAsyncDataSource };
export interface IDataServiceFunction<TDataType> {
    (): Promise<TDataType[]> | Observable<TDataType[]>;
}
export declare class DataServiceDataSource<TDataType> extends AsyncDataSource<TDataType> implements IAsyncDataSource<TDataType> {
    constructor(getDataSet: IDataServiceFunction<TDataType>, dataSourceProcessor: IDataSourceProcessor, array: __array.IArrayUtility);
}
