import { EventEmitter, QueryList } from '@angular/core';
import { services } from 'typescript-angular-utilities';
import __array = services.array;
import { IColumn } from './column';
import { ISortDirections, SortManagerService } from './sorts/index';
import { DataPager } from './paging/dataPager/dataPager.service';
import { CardContentTemplate, CardFooterTemplate } from '../cards/index';
import { ContainerHeaderTemplate, ContainerFooterTemplate, ColumnContentTemplate } from './templates/index';
import { ColumnHeaderTemplate } from './templates/columnHeader.template';
import { CardContainerComponent } from './cardContainer';
export declare const defaultSelectionTitle: string;
export interface ISelectableItem {
    viewData?: ISelectionViewData;
}
export interface ISelectionViewData {
    selected?: boolean;
    disabledSelection?: boolean;
    selectionTitle?: string;
}
export declare class SelectableCardContainerComponent<T extends ISelectableItem> extends CardContainerComponent<T> {
    selectionChanged: EventEmitter<void>;
    selectionColumn: IColumn<any>;
    sortDirections: ISortDirections;
    disableSelection: {
        (item: any): string;
    };
    containerHeader: ContainerHeaderTemplate;
    containerFooter: ContainerFooterTemplate;
    cardContent: CardContentTemplate;
    cardFooter: CardFooterTemplate;
    columnTemplates: QueryList<ColumnContentTemplate>;
    columnHeaders: QueryList<ColumnHeaderTemplate>;
    constructor(array: __array.ArrayUtility, pager: DataPager, sortManager: SortManagerService);
    ngOnInit(): void;
    sortSelected(): void;
    private addViewData;
    private clearFilteredSelections;
    private updateSelected;
    private updateDisabledSelections;
}
